#include <iostream>
using namespace std;
// -----------------------------------------------------------------------------

#include "avl.h"
// -----------------------------------------------------------------------------

avlnode* avl::fixBalance(avlnode* __node)
{
}
// -----------------------------------------------------------------------------

avl::avl(void)
{
     _root = NULL;
}
// -----------------------------------------------------------------------------

avl::~avl(void)
{
     while(_root)
          remove(_root->value());
}
// -----------------------------------------------------------------------------

void avl::insert(int __value)
{
     if(_root == NULL)
     {
          _root = new avlnode(__value);
          return;
     }
     
     avlnode* modChild = NULL;
     insertHelper(_root, __value, modChild);
}
// -----------------------------------------------------------------------------

bool avl::insertHelper(avlnode* __root, int __value, avlnode*& __modChild)
{
     bool insRes;
     avlnode* newLeaf = NULL;
     
     if(__value <= __root->value())
     {
          if(__root->left() != NULL)
               insRes = insertHelper(__root->left(), __value, __modChild);
          if(__root->left() == NULL)
          {
               newLeaf = new avlnode(__value);
               __root->setLeft(newLeaf);
               __modChild = __root;
               return __root->balance() != 0;
          }
     }
     if(__value > __root->value())
     {
          if(__root->right() != NULL)
               insRes = insertHelper(__root->right(), __value, __modChild);
          if(__root->right() == NULL)
          {
               newLeaf = new avlnode(__value);
               __root->setRight(newLeaf);
               __modChild = __root;
               return __root->balance() != 0;
          }
     }
     
      // jezeli trzeba poprawiac wysokosc drzewa
      int rb = __root->balance();                           // zapisujemy aktualna roznice wag
      if((rb == -2) || (rb == 2))
          fixBalance(__root);
     
     return false;
}
// -----------------------------------------------------------------------------

void avl::remove(int __key)
{
     avlnode* toRemove = findNode(__key);
     if(toRemove == NULL)     // nie znaleziono wezla o tej wartosci
          return;
     avlnode* toRemoveParent = parent(toRemove);
     
     // Gdy ma dwoch potomkow
     if((toRemove->left()) && (toRemove->right()))
     {
          int predVal = removePredescor(toRemove);
          toRemove->setValue(predVal);
     }
     
     // jezeli ma tylko lewego potomka
     else if((toRemove->left()) && (!toRemove->right()))
     {
          // Jezeli usuwany jest root-em
          if(toRemoveParent == NULL)
               _root = toRemove->left();
               
           // Jezeli usuwany nie jest root-em
           else if(toRemoveParent != NULL)
           {
               if(toRemoveParent->left() == toRemove)
               {
                    toRemoveParent->setLeft(toRemove->left());
                    fixBalanceAfterRemove(toRemoveParent, LEFT_CHILD);
               }
               if(toRemoveParent->right() == toRemove)
               {
                    toRemoveParent->setRight(toRemove->left());
                    fixBalanceAfterRemove(toRemoveParent, RIGHT_CHILD);
               }
           }
           delete toRemove;
     }
     
     // jezeli ma tylko prawego potomka lub  nie ma ich w ogole
     else if(!toRemove->left())
     {
          // Jezeli usuwany jest root-em
          if(toRemoveParent == NULL)
               _root = toRemove->right();
               
           // Jezeli usuwany nie jest root-em
           else if(toRemoveParent != NULL)
           {
               if(toRemoveParent->left() == toRemove)
               {
                    toRemoveParent->setLeft(toRemove->right());
                    fixBalanceAfterRemove(toRemoveParent, LEFT_CHILD);
               }
               if(toRemoveParent->right() == toRemove)
               {
                    toRemoveParent->setRight(toRemove->right());
                    fixBalanceAfterRemove(toRemoveParent, RIGHT_CHILD);
               }
           }
           delete toRemove;
     }
}
// -----------------------------------------------------------------------------

 int avl::removePredescor(avlnode* __node)
 {
     // poprzednik nie moze miec prawego potomka
     avlnode* pred = predescor(__node);
     avlnode* toPredParent = parent(pred);        // rodzic musi istniec
     int res = pred->value();
      
     if(toPredParent != __node)
     {
          toPredParent->setRight(pred->left());
          fixBalanceAfterRemove(toPredParent, RIGHT_CHILD);
     }
     else if(toPredParent == __node)
     {
          toPredParent->setLeft(pred->left());
          fixBalanceAfterRemove(toPredParent, LEFT_CHILD);
     }
     delete pred;
     
     return res;
 }
// -----------------------------------------------------------------------------

avlnode* avl::findNode(int __key)
{
     avlnode* result = _root;
     while((result != NULL) && (result->value() != __key))
     {
          if(result->value() > __key)
               result = result->left();
           else if(result->value() < __key)
               result = result->right();
     }
     return result;
}
// -----------------------------------------------------------------------------

avlnode* avl::parent(avlnode* __node)
{
     if(parentHelper(_root, __node))
          return __node;
     return NULL;
}
// -----------------------------------------------------------------------------

avlnode* avl::predescor(avlnode* __node)
{
     if(__node->left() == NULL)
          return NULL;
      avlnode* res = __node->left();
      while(res->right() != NULL)
          res = res->right();
      return res;
}
// -----------------------------------------------------------------------------

bool avl::parentHelper(avlnode* __node, avlnode*& __parent)
{
     if(__node == NULL)
          return false;
      if((__node->left() == __parent) || (__node->right() == __parent))
      {
          __parent = __node;
          return true;
      }
      
      if(parentHelper(__node->left(), __parent))
          return true;
      if(parentHelper(__node->right(), __parent))
          return true;
          
      return false;
}
// -----------------------------------------------------------------------------

avlnode* avl::rotRR(avlnode* __node)
{
     avlnode* nodeparent = parent(__node);
     avlnode* rightsubtree = __node->right();
     avlnode* leftsubsubtree = rightsubtree->left();
     
     // rotacja
     __node->setRight(leftsubsubtree);
     rightsubtree->setLeft(__node);
     if(!nodeparent)
          _root = rightsubtree;
      else if((nodeparent) && (nodeparent->right() == __node))
          nodeparent->setRight(rightsubtree);
      else if((nodeparent) && (nodeparent->left() == __node))
          nodeparent->setLeft(rightsubtree);

     return rightsubtree;
}
// -----------------------------------------------------------------------------

avlnode* avl::rotLL(avlnode* __node)
{
     avlnode* nodeparent = parent(__node);
     avlnode* leftsubtree = __node->left();
     avlnode* rightsubsubtree = leftsubtree->right();
     
     // rotacja
     __node->setLeft(rightsubsubtree);
     leftsubtree->setRight(__node);
     if(!nodeparent)
          _root = leftsubtree;
      else if((nodeparent) && (nodeparent->right() == __node))
          nodeparent->setRight(leftsubtree);
      else if((nodeparent) && (nodeparent->left() == __node))
          nodeparent->setLeft(leftsubtree);

     return leftsubtree;
}
// -----------------------------------------------------------------------------

avlnode* avl::rotRL(avlnode* __node)
{
     rotLL(__node->right());
     return rotRR(__node);
}
// -----------------------------------------------------------------------------

avlnode* avl::rotLR(avlnode* __node)
{
     rotRR(__node->left());
     return rotLL(__node);
}
// -----------------------------------------------------------------------------

void avl::fixBalanceAfterRemove(avlnode* __node, int __whichChild)
{
     bool continueloop;
     avlnode* __modChild = __whichChild == LEFT_CHILD ? __node->left() : __node->right();
     
     do
     {
          int bc = -2;
          int bn = __node->balance();

          if((bn == 1) || (bn == -1))
               continueloop = false;

          // jezeli skrocone zostalo lzejsze podrzewo
          if((__whichChild == RIGHT_CHILD) && (bn == 2))       //prawe
               bc = __node->left()->balance();
          // jezeli skrocone zostalo lzejsze podrzewo - lewe
          if((__whichChild == LEFT_CHILD) && (bn == -2))       // lewe
               bc = __node->right()->balance();

          if(bc != -2)
          {
               __node = fixBalance(__node);
               continueloop = bc != 0;
          }
          
          __modChild = __node;
          __node = parent(__node);
          if(__node != NULL)
               __whichChild = __node->left() == __modChild ? LEFT_CHILD : RIGHT_CHILD;
     }
     while((__node != NULL) && (continueloop));
}
// -----------------------------------------------------------------------------
// Metody pomocnicze
// -----------------------------------------------------------------------------

void avl::print(void)
{
     int recsize = _root->maxWeight();
      bool* a = new bool[recsize];
      for(int i=0;i<recsize;++i)
          a[i] = false;
     
     printHelper(a, _root, 0);
     delete [] a;
}
// ---------------------------------------------------------------------------

void avl::printHelper(bool* __a, avlnode* __node, int __indentSize)
{
     if(__node == NULL)
          return;

     avlnode* l = __node->left();
     avlnode* r = __node->right();
     avlnode* p = parent(__node);
    
    // Wlaczamy rysowanie krawedzi od rodzica bierzacego wezla
    __a[__indentSize] = true;
    
    // Wylaczamy rysowanie krawedzi od innych wezlow - drzewo rosnie w dol natomiast prawe podrzewo jest wypisywane w gornej czesci swojego rodzica
    if((p != NULL) && (p->right() == __node))
          __a[__indentSize-1] = false;
    
    // Wypisywanie prawego podrzewa
     if(r != NULL)
          printHelper(__a, r, __indentSize+1);

     // Wlaczamy rysowanie krawedzi od innych wezlow - drzewo rosnie w dol natomiast lewe podrzewo jest wypisywane w dolnej czesci swojego rodzica
     if(__indentSize > 0)
          __a[__indentSize-1] = true;
          
    // Wypisywanie bierzacego wezla
     for(int i=0;i<__indentSize;++i)
     {
          if(i == (__indentSize-1))
               cout << "|-------";
          else if(__a[i])
               cout << "|\t";
          else
               cout << "\t";
     }
      cout << __node->value() << "(" << __node->balance()  << ")" << endl;
      
      // Wylaczamy rysowanie krawedzi od innych wezlow - wszystkie krawedzie wezlow poprzednikow juz sa narysowane
      if((p != NULL) && (p->left() == __node))
          __a[__indentSize-1] = false;
          
     // Wypisywanie lewego podrzewa
     if(l != NULL)
          printHelper(__a, l, __indentSize+1);
}
// -----------------------------------------------------------------------------
