#include <iostream>
using namespace std;
// -----------------------------------------------------------------------------

#include "avlnode.h"
// -----------------------------------------------------------------------------

avlnode::avlnode(void) 
{
     _left = NULL;
     _right = NULL;
     _lweight = 0;
     _rweight = 0;
}
// -----------------------------------------------------------------------------

avlnode::avlnode(int __value) : _value(__value)
{
     _left = NULL;
     _right = NULL;
     _lweight = 0;
     _rweight = 0;
}
// -----------------------------------------------------------------------------

avlnode* avlnode::left(void) 
{ 
     return _left;
}
// -----------------------------------------------------------------------------

avlnode* avlnode::right(void) 
{
     return _right; 
}
// -----------------------------------------------------------------------------

int avlnode::leftWeight(void)
{
     if(_left == NULL)
          return 0;
     return _left->maxWeight()+1;
}
// -----------------------------------------------------------------------------

int avlnode::rightWeight(void)
{
     if(_right == NULL)
          return 0;
     return _right->maxWeight()+1;
}
// -----------------------------------------------------------------------------

int avlnode::maxWeight(void)
{
     int lweight = leftWeight();
     int rweight = rightWeight();
     
     return lweight>rweight?lweight:rweight;
}
// -----------------------------------------------------------------------------

int avlnode::balance(void)
{
     return leftWeight() - rightWeight();
}
// -----------------------------------------------------------------------------

int avlnode::value(void) 
{ 
     return _value; 
}
// -----------------------------------------------------------------------------

void avlnode::setLeft(avlnode* __leftnode) 
{
     _left = __leftnode; 
}
// -----------------------------------------------------------------------------

void avlnode::setRight(avlnode* __rightnode) 
{ 
     _right = __rightnode; 
}
// -----------------------------------------------------------------------------

void avlnode::setValue(int __value) 
{ 
     _value = __value; 
}
// -----------------------------------------------------------------------------
