#include <iostream>
using namespace std;
// -----------------------------------------------------------------------------

#include "binary-heap.h"
// -----------------------------------------------------------------------------

void binary_heap::buildHeap(const int* __array, int __size)
{
}
// ---------------------------------------------------------------------------

int* binary_heap::sort(void)
{
}
// ---------------------------------------------------------------------------

binary_heap::binary_heap(void)
{
     _valtab = NULL;
     _size = 0;
}
// ---------------------------------------------------------------------------

binary_heap::~binary_heap(void)
{
     clear();
}
// ---------------------------------------------------------------------------

int binary_heap::parent(int __index)
{
     if(__index == 0)
          return -1;
      int idx = __index+1;
      idx = idx >> 1;
      return idx-1;
}
// ---------------------------------------------------------------------------

int binary_heap::left(int __index)
{
     if(__index < 0)
          return -1;
          
     int idx = __index+1;
      idx = idx << 1;
      idx--;
      if(idx >= size())
          return -1;
      
      return idx;
}
// ---------------------------------------------------------------------------

int binary_heap::right(int __index)
{
      if(__index < 0)
          return -1;
          
     int idx = __index+1;
      idx = idx << 1;
       if(idx >= size())
          return -1;
          
      return idx;
}
// ---------------------------------------------------------------------------

void binary_heap::heapify(int __index)
{
     int l = left(__index);
     int r = right(__index);
     int m = __index;              // indeks wartosci maksymalnej
     
     if((l != -1) && (_valtab[l] > _valtab[m]))
          m = l;
     if((r != -1) && (_valtab[r] > _valtab[m]))
          m = r;
     if(m != __index)
     {
          swap(__index, m);
          heapify(m);
     }
}
// ---------------------------------------------------------------------------

int binary_heap::maximum(void)
{
     if(size() <= 0)
          return -1;
          
     return _valtab[0];
}
// ---------------------------------------------------------------------------

int binary_heap::extract(void)
{
     if(size() <= 0)
          throw "Kopiec pusty";
          
     int m = maximum();
     _valtab[0] = _valtab[size()-1];
     resizeHeap(false);
     heapify(0);
     
     return m;
}
// ---------------------------------------------------------------------------

void binary_heap::increase(int __index, int __newvalue)
{
     if((__index < 0) || (__index >= size()) || (_valtab[__index] > __newvalue))
          return;
          
      _valtab[__index] = __newvalue;
      int p = parent(__index);
      while((p != -1) && (_valtab[p] < _valtab[__index]))
      {
          swap(p, __index);
          __index = p;
          p = parent(p);
      }
}
// ---------------------------------------------------------------------------

void binary_heap::insert(int __val)
{
     resizeHeap(true);
     _valtab[size()-1] = NEG_INF;
     increase(size()-1, __val);
}
// ---------------------------------------------------------------------------
// Metody pomocnicze
// ---------------------------------------------------------------------------

void binary_heap::clear(void)
{
     if(_size > 0)
          delete [] _valtab;
      _valtab = NULL;
      _size = 0;
}
// ---------------------------------------------------------------------------

void binary_heap::resizeHeap(bool __increase)
{
     int cs = size();                                 // CurrentSize
     int ns = __increase?cs+1:cs-1;     // NewSize
     int ms = cs<ns?cs:ns;                    // MinimalSize
     
     int* tmp = new int[ns];
     for(int i=0;i<ms;++i)
          tmp[i] = _valtab[i];
          
      if(cs > 0)
          delete [] _valtab;
      _valtab = tmp;
      _size = ns;
}
// ---------------------------------------------------------------------------

void binary_heap::shift(void)
{
     for(int i=0;i<size()-1;++i)
          _valtab[i] = _valtab[i+1];
}
// ---------------------------------------------------------------------------

void binary_heap::swap(int __index1, int __index2)
{
     if((__index1 < 0) || (__index1 >= size()) || (__index2 < 0) || (__index2 >= size()))
          return;
     int tmp = _valtab[__index1];
     _valtab[__index1] = _valtab[__index2];
     _valtab[__index2] = tmp;
}
// ---------------------------------------------------------------------------

int binary_heap::size(void)
{
     return _size;
}
// ---------------------------------------------------------------------------

int binary_heap::height(void)
{
     if(size() == 0)
          return 0;
     
     int height = 1;
     int p = size()-1;
     while((p = parent(p)) > -1)
          height++;
          
      return height;
}
// ---------------------------------------------------------------------------

void binary_heap::print(void)
{
     int recsize = height();
      bool* a = new bool[recsize];
      for(int i=0;i<recsize;++i)
          a[i] = false;
     
     printHelper(a, 0, 0);
     delete [] a;
}
// ---------------------------------------------------------------------------

void binary_heap::printHelper(bool* __a, int __index, int __indentSize)
{
     if((__index < 0) || (__index >= size()))
          return;

     int l = left(__index);
     int r = right(__index);
     int p = parent(__index);
    
    __a[__indentSize] = true;
    if((p != -1) && (right(p) == __index))
          __a[__indentSize-1] = false;
    
    // Wypisywanie prawego podrzewa
     if(r != -1)
          printHelper(__a, r, __indentSize+1);

     if(__indentSize > 0)
     __a[__indentSize-1] = true;
          
    // Wypisywanie bierzacego wezla
     for(int i=0;i<__indentSize;++i)
     {
          if(i == (__indentSize-1))
               cout << "|-------";
          else if(__a[i])
               cout << "|\t";
          else
               cout << "\t";
     }
      cout << _valtab[__index]<< endl;
      
      if((p != -1) && (left(p) == __index))
          __a[__indentSize-1] = false;
          
     // Wypisywanie lewego podrzewa
     if(l != -1)
          printHelper(__a, l, __indentSize+1);
}
// ---------------------------------------------------------------------------